"""
    FactSet Ownership API

    FactSet's Fund Ownership API gives access to both **Holdings**, **Holders**, and **Transactions** data.<p> Factset's Holdings endpoints gives access to all the underlying securities and their position details held within a given fund. Fund Types supported include Open-End Mutual Funds, Closed-end Mutual Funds, and Exchange Traded Funds. Security Holders information retrieves all \"holder types\" and their positions across institutions, funds, insiders, and stakeholders. FactSet also provides extensive insider and institutional transactions data for multiple countries including the United States, China, and Canada.</p><p>The FactSet Ownership and Mutual Funds database collects global equity ownership data for approximately 50,000 institutions, 60,000 unique Mutual Fund portfolios, and 400,000 Insider/Stakeholders from around 110 countries. For more details review our [Data Collection](https://my.apps.factset.com/oa/cms/oaAttachment/87e162be-f2d1-4f40-a85b-bfb1b020d270/20079) methodology. </p>   # noqa: E501

    The version of the OpenAPI document: 1.2.0
    Contact: api@factset.com
    Generated by: https://openapi-generator.tech
"""


import re  # noqa: F401
import sys  # noqa: F401

from fds.sdk.FactSetOwnership.model_utils import (  # noqa: F401
    ApiTypeError,
    ModelComposed,
    ModelNormal,
    ModelSimple,
    cached_property,
    change_keys_js_to_python,
    convert_js_args_to_python_args,
    date,
    datetime,
    file_type,
    none_type,
    validate_get_composed_info,
    OpenApiModel
)
from fds.sdk.FactSetOwnership.exceptions import ApiAttributeError



class InsiderTransactions(ModelNormal):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.

    Attributes:
      allowed_values (dict): The key is the tuple path to the attribute
          and the for var_name this is (var_name,). The value is a dict
          with a capitalized key describing the allowed value and an allowed
          value. These dicts store the allowed enum values.
      attribute_map (dict): The key is attribute name
          and the value is json key in definition.
      discriminator_value_class_map (dict): A dict to go from the discriminator
          variable value to the discriminator class name.
      validations (dict): The key is the tuple path to the attribute
          and the for var_name this is (var_name,). The value is a dict
          that stores validations for max_length, min_length, max_items,
          min_items, exclusive_maximum, inclusive_maximum, exclusive_minimum,
          inclusive_minimum, and regex.
      additional_properties_type (tuple): A tuple of classes accepted
          as additional properties values.
    """

    allowed_values = {
    }

    validations = {
    }

    @cached_property
    def additional_properties_type():
        """
        This must be a method because a model may have properties that are
        of type self, this must run after the class is loaded
        """
        return (bool, date, datetime, dict, float, int, list, str, none_type,)  # noqa: E501

    _nullable = False

    @cached_property
    def openapi_types():
        """
        This must be a method because a model may have properties that are
        of type self, this must run after the class is loaded

        Returns
            openapi_types (dict): The key is attribute name
                and the value is attribute type.
        """
        return {
            'request_id': (str,),  # noqa: E501
            'fsym_id': (str, none_type,),  # noqa: E501
            'currency': (str, none_type,),  # noqa: E501
            'holder_name': (str, none_type,),  # noqa: E501
            'holder_title': (str, none_type,),  # noqa: E501
            'holder_id': (str, none_type,),  # noqa: E501
            'shares': (float, none_type,),  # noqa: E501
            'price': (float, none_type,),  # noqa: E501
            'net_value_change': (float, none_type,),  # noqa: E501
            'filing_date': (str, none_type,),  # noqa: E501
            'is_derivative': (bool, none_type,),  # noqa: E501
            'is_direct': (bool, none_type,),  # noqa: E501
            'trade_type': (str, none_type,),  # noqa: E501
            'form_type': (str, none_type,),  # noqa: E501
            'transaction_date': (str, none_type,),  # noqa: E501
            'shares_owned': (float, none_type,),  # noqa: E501
            'sec_rule10b51': (bool, none_type,),  # noqa: E501
        }

    @cached_property
    def discriminator():
        return None


    attribute_map = {
        'request_id': 'requestId',  # noqa: E501
        'fsym_id': 'fsymId',  # noqa: E501
        'currency': 'currency',  # noqa: E501
        'holder_name': 'holderName',  # noqa: E501
        'holder_title': 'holderTitle',  # noqa: E501
        'holder_id': 'holderId',  # noqa: E501
        'shares': 'shares',  # noqa: E501
        'price': 'price',  # noqa: E501
        'net_value_change': 'netValueChange',  # noqa: E501
        'filing_date': 'filingDate',  # noqa: E501
        'is_derivative': 'isDerivative',  # noqa: E501
        'is_direct': 'isDirect',  # noqa: E501
        'trade_type': 'tradeType',  # noqa: E501
        'form_type': 'formType',  # noqa: E501
        'transaction_date': 'transactionDate',  # noqa: E501
        'shares_owned': 'sharesOwned',  # noqa: E501
        'sec_rule10b51': 'secRule10b51',  # noqa: E501
    }

    read_only_vars = {
    }

    _composed_schemas = {}

    @classmethod
    @convert_js_args_to_python_args
    def _from_openapi_data(cls, *args, **kwargs):  # noqa: E501
        """InsiderTransactions - a model defined in OpenAPI

        Keyword Args:
            _check_type (bool): if True, values for parameters in openapi_types
                                will be type checked and a TypeError will be
                                raised if the wrong type is input.
                                Defaults to True
            _path_to_item (tuple/list): This is a list of keys or values to
                                drill down to the model in received_data
                                when deserializing a response
            _spec_property_naming (bool): True if the variable names in the input data
                                are serialized names, as specified in the OpenAPI document.
                                False if the variable names in the input data
                                are pythonic names, e.g. snake case (default)
            _configuration (Configuration): the instance to use when
                                deserializing a file_type parameter.
                                If passed, type conversion is attempted
                                If omitted no type conversion is done.
            _visited_composed_classes (tuple): This stores a tuple of
                                classes that we have traveled through so that
                                if we see that class again we will not use its
                                discriminator again.
                                When traveling through a discriminator, the
                                composed schema that is
                                is traveled through is added to this set.
                                For example if Animal has a discriminator
                                petType and we pass in "Dog", and the class Dog
                                allOf includes Animal, we move through Animal
                                once using the discriminator, and pick Dog.
                                Then in Dog, we will make an instance of the
                                Animal class but this time we won't travel
                                through its discriminator because we passed in
                                _visited_composed_classes = (Animal,)
            request_id (str): Identifier that was used in the request.. [optional]  # noqa: E501
            fsym_id (str, none_type): FactSet Security Identifier of Fund. Identifies the security level id of the Fund requested (not-representing the underlying holding). Six alpha-numeric characters, excluding vowels, with an -S suffix (XXXXXX-S). All equity and fixed income securities that exist on FactSet are allocated a security-level permanent identifier.. [optional]  # noqa: E501
            currency (str, none_type): Currency code. The service will default to the funds local currency. For a list of currency ISO codes, visit [Online Assistant Page #1470](https://oa.apps.factset.com/pages/1470).. [optional]  # noqa: E501
            holder_name (str, none_type): Returns the names of the insiders involved in the transactions that occurred between the specified start and end dates.. [optional]  # noqa: E501
            holder_title (str, none_type): Returns the titles of the insiders involved in the transactions that occurred between the specified start and end dates.. [optional]  # noqa: E501
            holder_id (str, none_type): Returns the holder IDs for the insiders involved in the transactions that occurred between the specified start and end dates.. [optional]  # noqa: E501
            shares (float, none_type): Returns the transaction shares for the transactions that occurred between the specified start and end dates.. [optional]  # noqa: E501
            price (float, none_type): Returns the transaction prices for the transactions that occurred between the specified start and end dates.. [optional]  # noqa: E501
            net_value_change (float, none_type): Returns the transaction values for the transactions that occurred between the specified start and end dates.. [optional]  # noqa: E501
            filing_date (str, none_type): Returns the dates on which the transactions that occurred between the specified start and end dates were processed.. [optional]  # noqa: E501
            is_derivative (bool, none_type): Returns a Derivative/Non-Derivative flag for the transactions that occurred between the specified start and end dates. Returns true for Derivative and false for Non-Derivative.. [optional]  # noqa: E501
            is_direct (bool, none_type): Returns a direct/indirect flag for the transactions that occurred between the specified start and end dates.. [optional]  # noqa: E501
            trade_type (str, none_type): Returns an acquisition/disposition flag for the transactions that occurred between the specified start and end dates.. [optional]  # noqa: E501
            form_type (str, none_type): Returns the form types for the transactions that occurred between the specified start and end dates.. [optional]  # noqa: E501
            transaction_date (str, none_type): Returns the transaction dates for the transactions that occurred between the specified start and end dates.. [optional]  # noqa: E501
            shares_owned (float, none_type): Returns the shares owned data for the transactions that occurred between the specified start and end dates.. [optional]  # noqa: E501
            sec_rule10b51 (bool, none_type): Returns rule 10b5-1 flags for the insiders involved in the transactions that occurred between the specified start and end dates.. [optional]  # noqa: E501
        """

        _check_type = kwargs.pop('_check_type', True)
        _spec_property_naming = kwargs.pop('_spec_property_naming', False)
        _path_to_item = kwargs.pop('_path_to_item', ())
        _configuration = kwargs.pop('_configuration', None)
        _visited_composed_classes = kwargs.pop('_visited_composed_classes', ())

        self = super(OpenApiModel, cls).__new__(cls)

        if args:
            raise ApiTypeError(
                "Invalid positional arguments=%s passed to %s. Remove those invalid positional arguments." % (
                    args,
                    self.__class__.__name__,
                ),
                path_to_item=_path_to_item,
                valid_classes=(self.__class__,),
            )

        self._data_store = {}
        self._check_type = _check_type
        self._spec_property_naming = _spec_property_naming
        self._path_to_item = _path_to_item
        self._configuration = _configuration
        self._visited_composed_classes = _visited_composed_classes + (self.__class__,)

        for var_name, var_value in kwargs.items():
            if var_name not in self.attribute_map and \
                        self._configuration is not None and \
                        self._configuration.discard_unknown_keys and \
                        self.additional_properties_type is None:
                # discard variable.
                continue
            setattr(self, var_name, var_value)
        return self

    required_properties = set([
        '_data_store',
        '_check_type',
        '_spec_property_naming',
        '_path_to_item',
        '_configuration',
        '_visited_composed_classes',
    ])

    @convert_js_args_to_python_args
    def __init__(self, *args, **kwargs):  # noqa: E501
        """InsiderTransactions - a model defined in OpenAPI

        Keyword Args:
            _check_type (bool): if True, values for parameters in openapi_types
                                will be type checked and a TypeError will be
                                raised if the wrong type is input.
                                Defaults to True
            _path_to_item (tuple/list): This is a list of keys or values to
                                drill down to the model in received_data
                                when deserializing a response
            _spec_property_naming (bool): True if the variable names in the input data
                                are serialized names, as specified in the OpenAPI document.
                                False if the variable names in the input data
                                are pythonic names, e.g. snake case (default)
            _configuration (Configuration): the instance to use when
                                deserializing a file_type parameter.
                                If passed, type conversion is attempted
                                If omitted no type conversion is done.
            _visited_composed_classes (tuple): This stores a tuple of
                                classes that we have traveled through so that
                                if we see that class again we will not use its
                                discriminator again.
                                When traveling through a discriminator, the
                                composed schema that is
                                is traveled through is added to this set.
                                For example if Animal has a discriminator
                                petType and we pass in "Dog", and the class Dog
                                allOf includes Animal, we move through Animal
                                once using the discriminator, and pick Dog.
                                Then in Dog, we will make an instance of the
                                Animal class but this time we won't travel
                                through its discriminator because we passed in
                                _visited_composed_classes = (Animal,)
            request_id (str): Identifier that was used in the request.. [optional]  # noqa: E501
            fsym_id (str, none_type): FactSet Security Identifier of Fund. Identifies the security level id of the Fund requested (not-representing the underlying holding). Six alpha-numeric characters, excluding vowels, with an -S suffix (XXXXXX-S). All equity and fixed income securities that exist on FactSet are allocated a security-level permanent identifier.. [optional]  # noqa: E501
            currency (str, none_type): Currency code. The service will default to the funds local currency. For a list of currency ISO codes, visit [Online Assistant Page #1470](https://oa.apps.factset.com/pages/1470).. [optional]  # noqa: E501
            holder_name (str, none_type): Returns the names of the insiders involved in the transactions that occurred between the specified start and end dates.. [optional]  # noqa: E501
            holder_title (str, none_type): Returns the titles of the insiders involved in the transactions that occurred between the specified start and end dates.. [optional]  # noqa: E501
            holder_id (str, none_type): Returns the holder IDs for the insiders involved in the transactions that occurred between the specified start and end dates.. [optional]  # noqa: E501
            shares (float, none_type): Returns the transaction shares for the transactions that occurred between the specified start and end dates.. [optional]  # noqa: E501
            price (float, none_type): Returns the transaction prices for the transactions that occurred between the specified start and end dates.. [optional]  # noqa: E501
            net_value_change (float, none_type): Returns the transaction values for the transactions that occurred between the specified start and end dates.. [optional]  # noqa: E501
            filing_date (str, none_type): Returns the dates on which the transactions that occurred between the specified start and end dates were processed.. [optional]  # noqa: E501
            is_derivative (bool, none_type): Returns a Derivative/Non-Derivative flag for the transactions that occurred between the specified start and end dates. Returns true for Derivative and false for Non-Derivative.. [optional]  # noqa: E501
            is_direct (bool, none_type): Returns a direct/indirect flag for the transactions that occurred between the specified start and end dates.. [optional]  # noqa: E501
            trade_type (str, none_type): Returns an acquisition/disposition flag for the transactions that occurred between the specified start and end dates.. [optional]  # noqa: E501
            form_type (str, none_type): Returns the form types for the transactions that occurred between the specified start and end dates.. [optional]  # noqa: E501
            transaction_date (str, none_type): Returns the transaction dates for the transactions that occurred between the specified start and end dates.. [optional]  # noqa: E501
            shares_owned (float, none_type): Returns the shares owned data for the transactions that occurred between the specified start and end dates.. [optional]  # noqa: E501
            sec_rule10b51 (bool, none_type): Returns rule 10b5-1 flags for the insiders involved in the transactions that occurred between the specified start and end dates.. [optional]  # noqa: E501
        """

        _check_type = kwargs.pop('_check_type', True)
        _spec_property_naming = kwargs.pop('_spec_property_naming', False)
        _path_to_item = kwargs.pop('_path_to_item', ())
        _configuration = kwargs.pop('_configuration', None)
        _visited_composed_classes = kwargs.pop('_visited_composed_classes', ())

        if args:
            raise ApiTypeError(
                "Invalid positional arguments=%s passed to %s. Remove those invalid positional arguments." % (
                    args,
                    self.__class__.__name__,
                ),
                path_to_item=_path_to_item,
                valid_classes=(self.__class__,),
            )

        self._data_store = {}
        self._check_type = _check_type
        self._spec_property_naming = _spec_property_naming
        self._path_to_item = _path_to_item
        self._configuration = _configuration
        self._visited_composed_classes = _visited_composed_classes + (self.__class__,)

        for var_name, var_value in kwargs.items():
            if var_name not in self.attribute_map and \
                        self._configuration is not None and \
                        self._configuration.discard_unknown_keys and \
                        self.additional_properties_type is None:
                # discard variable.
                continue
            setattr(self, var_name, var_value)
            if var_name in self.read_only_vars:
                raise ApiAttributeError(f"`{var_name}` is a read-only attribute. Use `from_openapi_data` to instantiate "
                                     f"class with read only attributes.")
